﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Megawin_Easy_USB_CSharp_x64
{
    public partial class Form1 : Form
    {
        MW_EasyPOD EasyPOD;
        public Form1()
        {
            InitializeComponent();
        }

        unsafe private void buttonWriteBytes_Click(object sender, EventArgs e)
        {
            byte[] WriteBuffer;
            UInt32 uiLength, uiWritten, uiResult;
            if (textBoxWriteBuffer.TextLength == 0)
                return;
            uiLength = TransformData(out WriteBuffer);
            if (comboBoxDevices.SelectedIndex == 0) // EasyPOD
            {
                fixed (MW_EasyPOD* pPOD = &EasyPOD)
                {
                    uiResult = PODfuncs.WriteData(pPOD, WriteBuffer, uiLength, &uiWritten);
                    if (uiResult == 0x00)
                        toolStripStatusLabel1.Text = "Write Return Size is : " + uiWritten;
                    else
                        toolStripStatusLabel1.Text = "Write Failed !";
                }

            }
            else  // COM
            {
                serialPort1.Write(WriteBuffer, 0, (Int32)uiLength);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string strTmp;
            for (int i = 0; i < 15; i++)
            {
                strTmp = "COM" + (i + 1);
                comboBoxPorts.Items.Add(strTmp);
            }
            comboBoxPorts.SelectedIndex = 0;
            comboBoxPorts.Visible = false;

            comboBoxBaudrate.Items.Add("1200");
            comboBoxBaudrate.Items.Add("2400");
            comboBoxBaudrate.Items.Add("4800");
            comboBoxBaudrate.Items.Add("9600");
            comboBoxBaudrate.Items.Add("14400");
            comboBoxBaudrate.Items.Add("19200");
            comboBoxBaudrate.Items.Add("28800");
            comboBoxBaudrate.Items.Add("38400");
            comboBoxBaudrate.Items.Add("56000");
            comboBoxBaudrate.Items.Add("57600");
            comboBoxBaudrate.Items.Add("115200");
            comboBoxBaudrate.SelectedIndex = 3;
            comboBoxBaudrate.Visible = false;

            comboBoxDevices.Items.Add("EasyPOD");
            comboBoxDevices.Items.Add("EasyCOM");
            comboBoxDevices.SelectedIndex = 0;
           

            labelVID.Visible = true;
            labelPID.Visible = true;
            labelIndex.Visible = true;
            textBoxVID.Visible = true;
            textBoxPID.Visible = true;
            textBoxIndex.Visible = true;
            textBoxVID.Text = "0E6A";
            textBoxPID.Text = "0317";
            textBoxIndex.Text = "1";

            groupBoxSetting.Text = "POD Setting";

            radioButtonString.Checked = true;
        }

        unsafe private void buttonConnect_Click(object sender, EventArgs e)
        {
            UInt32 dwResult, Index;
            String strTmp;

            if (comboBoxDevices.SelectedIndex == 0) // EasyPOD
            {
                if ((textBoxVID.TextLength == 0) || (textBoxPID.TextLength == 0) || (textBoxIndex.TextLength == 0))
                {
                    MessageBox.Show("VID or PID or Index must have value !", "EasyPOD");
                    return;
                }
                strTmp = textBoxVID.Text;
                EasyPOD.VID = Convert.ToUInt32(strTmp, 16);
                strTmp = textBoxPID.Text;
                EasyPOD.PID = Convert.ToUInt32(strTmp, 16);
                strTmp = textBoxIndex.Text;
                Index = Convert.ToUInt32(strTmp, 10);

                fixed (MW_EasyPOD* pPOD = &EasyPOD)
                {
                    dwResult = PODfuncs.ConnectPOD(pPOD, Index);
                    if (dwResult == 0)
                        toolStripStatusLabel1.Text = "Connect OK !";
                    else
                        toolStripStatusLabel1.Text = "Fail Connect to Megawin EasyPOD !";
                }
            }
            else  // EasyCOM
            {
                if (serialPort1.IsOpen == true)
                    serialPort1.Close();
                serialPort1.PortName = comboBoxPorts.Text;
                serialPort1.BaudRate = Convert.ToInt32(comboBoxBaudrate.Text, 10);
                serialPort1.ReadTimeout = 0;
                serialPort1.Open();
                toolStripStatusLabel1.Text = "Connect OK !";
            }
        }

        private void comboBoxDevices_SelectedIndexChanged(object sender, EventArgs e)        
        {            
            Int32 i;
            i = comboBoxDevices.SelectedIndex;
            if (i == 0)  //EasyPOD
            {
                comboBoxBaudrate.Visible = false;
                comboBoxPorts.Visible = false;

                groupBoxSetting.Text = "POD Setting";
                textBoxPID.Visible = true;
                textBoxVID.Visible = true;
                textBoxIndex.Visible = true;
                labelVID.Visible = true;
                labelPID.Visible = true;
                labelIndex.Visible = true;
                groupBoxSetting.Height = 109;
            }
            else
            {
                comboBoxBaudrate.Visible = true;
                comboBoxPorts.Visible = true;

                groupBoxSetting.Text = "COM Setting";
                textBoxPID.Visible = false;
                textBoxVID.Visible = false;
                textBoxIndex.Visible = false;
                labelVID.Visible = false;
                labelPID.Visible = false;
                labelIndex.Visible = false;
                groupBoxSetting.Height = 80;
            }
        }

        private void buttonExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void radioButtonString_CheckedChanged(object sender, EventArgs e)
        {
            textBoxWriteBuffer.Clear();
            textBoxWriteBuffer.CharacterCasing = System.Windows.Forms.CharacterCasing.Normal;
        }

        private void radioButtonHex_CheckedChanged(object sender, EventArgs e)
        {
            textBoxWriteBuffer.Clear();
            textBoxWriteBuffer.CharacterCasing = System.Windows.Forms.CharacterCasing.Upper;
        }

        unsafe private void buttonDisconnect_Click(object sender, EventArgs e)
        {
            UInt32 dwResult;
            if (comboBoxDevices.SelectedIndex == 0) // EasyPOD
            {
                fixed (MW_EasyPOD* pPOD = &EasyPOD)
                {
                    if ((pPOD->Handle.ToInt64() != Convert.ToInt64(0)) && (pPOD->Handle.ToInt64() != Convert.ToInt64(0xFFFFFFFF)))
                    {
                        dwResult = PODfuncs.DisconnectPOD(pPOD);
                        if (dwResult == 0x00)
                            toolStripStatusLabel1.Text = "Disconnect OK !";
                        else
                            toolStripStatusLabel1.Text = "Fail To Disconnect Megawin EasyPOD !";
                    }
                }
            }
            else
            {
                if (serialPort1.IsOpen == true)
                    serialPort1.Close();
                toolStripStatusLabel1.Text = "Disconnect OK !";
            }
        }
        private UInt32 TransformData(out byte[] buffer)
        {
            UInt32 DataLength;
            Int32 StringLength;
            Int32 i;
            string strTmp;
            string strToken;
            strTmp = textBoxWriteBuffer.Text;
            StringLength = textBoxWriteBuffer.TextLength;
            ASCIIEncoding AE = new ASCIIEncoding();
            if (radioButtonString.Checked == true)
            {
                buffer = new byte[StringLength];
                buffer = AE.GetBytes(strTmp);
                DataLength = (UInt32)StringLength;
            }
            else
            {
                buffer = new byte[(StringLength + 2) / 3];
                for (i = 0; (i * 3) < StringLength; i++)
                {
                    strToken = strTmp.Substring((i * 3), 2);
                    buffer[i] = HexByteToDec(strToken);
                }
                DataLength = (UInt32)i;
            }
            return DataLength;
        }
        private byte HexByteToDec(string strTmp)
        {
            byte bytReturn;
            char chTrans;

            chTrans = strTmp[0];
            if ((chTrans >= '0') && (chTrans <= '9'))
                bytReturn = (byte)(16 * (chTrans - 48));
            else
                bytReturn = (byte)(16 * ((chTrans - 'A') + 10));
            chTrans = strTmp[1];

            if ((chTrans >= '0') && (chTrans <= '9'))
                bytReturn = (byte)(bytReturn + (byte)(chTrans - 48));
            else
                bytReturn = (byte)(bytReturn + (byte)((chTrans - 'A') + 10));
            return bytReturn;
        }

        unsafe private void buttonReadBytes_Click(object sender, EventArgs e)
        {
            byte[] ReadBuffer = new byte[0x40];
            string strOutput;
            UInt32 uiLength, uiRead, uiResult;
            UInt32 uiTotalLength;
            Int16 i;
            if (comboBoxDevices.SelectedIndex == 0)  // EasyPOD
            {
                fixed (MW_EasyPOD* pPOD = &EasyPOD)
                {
                    uiTotalLength = 0;
                    uiLength = 0x40;
                    strOutput = "";
                    do
                    {
                        uiResult = PODfuncs.ReadData(pPOD, ReadBuffer, uiLength, &uiRead);
                        if ((uiResult == 0x00) || ((uiRead > 0) && (uiResult == 0xE0000008)))
                        {
                            uiTotalLength = uiTotalLength + uiRead;
                            if (radioButtonString.Checked == true)
                            {
                                for (i = 0; i < uiRead; i++)
                                    strOutput = strOutput + (char)ReadBuffer[i];
                            }
                            else
                                strOutput = strOutput + BitConverter.ToString(ReadBuffer, 0, (Int32)uiRead).Replace("-", " ");
                        }
                        textBoxReadBuffer.Text = strOutput;
                        toolStripStatusLabel1.Text = "Read return size is : " + uiTotalLength;
                    } while (uiResult == 0);
                }
            }
            else
            {
                uiTotalLength = 0;
                strOutput = "";
                do
                {
                    uiRead = 0;
                    try
                    {
                        uiRead = (UInt32)(serialPort1.Read(ReadBuffer, 0, serialPort1.BytesToRead));
                        if (uiRead > 0)
                        {
                            uiTotalLength = uiTotalLength + uiRead;
                            if (radioButtonString.Checked == true)
                            {
                                for (i=0 ; i<uiRead ; i++)
                                    strOutput = strOutput + (char)ReadBuffer[i];
                            }
                            else
                            {
                                strOutput = strOutput + BitConverter.ToString(ReadBuffer, 0, (Int32)uiRead).Replace("-", " ");
                            }
                        }
                        textBoxReadBuffer.Text = strOutput;
                        toolStripStatusLabel1.Text = "Read return size is : " + uiTotalLength;
                    }
                    catch (TimeoutException) {;}
                } while (uiRead > 0);
            }
        }

        private void textBoxWriteBuffer_KeyPress(object sender, KeyPressEventArgs e)
        {
            Int32 TxtLength = 0;
            Int32 SelectStartIndex = 0;
            Int32 Length = 0;
            string strOld;
            string strModify;
            if (radioButtonHex.Checked == true)            
            {
                if (e.KeyChar == 8)
                {                    
                    strOld = textBoxWriteBuffer.Text;
                    TxtLength = textBoxWriteBuffer.TextLength;
                    if (TxtLength > 0)
                    {
                        SelectStartIndex = textBoxWriteBuffer.SelectionStart;
                        Length = ((SelectStartIndex / 3 + 1)) * 3;
                        if (Length <= TxtLength)
                        {
                            strModify = strOld.Substring(Length);
                            if (strModify.Length % 3 != 0)
                                strModify = strModify + " ";
                        }
                        else
                            strModify = "";

                        Length = ((SelectStartIndex - 1) / 3) * 3;
                        textBoxWriteBuffer.Text = strOld.Substring(0, Length) + strModify;
                        textBoxWriteBuffer.SelectionStart = textBoxWriteBuffer.TextLength;
                    }
                    e.Handled = true;
                }
                else if ((e.KeyChar >= 48) && (e.KeyChar <= 57))
                {
                    strOld = textBoxWriteBuffer.Text;
                    TxtLength = textBoxWriteBuffer.TextLength;
                    if (TxtLength % 3 == 0)
                    {
                        strModify = "0" + e.KeyChar;
                    }
                    else if (TxtLength % 3 == 2)
                    {
                        strModify = strOld.Substring(TxtLength - 1, 1) + e.KeyChar + " ";
                        strOld = strOld.Substring(0, TxtLength - 2);
                    }
                    else
                    {
                        strModify = "";
                    }
                    textBoxWriteBuffer.Text = strOld + strModify;
                    textBoxWriteBuffer.SelectionStart = textBoxWriteBuffer.TextLength;
                    e.Handled = true;
                }
                else if ((e.KeyChar >= 65) && (e.KeyChar <= 70))
                {
                    strOld = textBoxWriteBuffer.Text;
                    TxtLength = textBoxWriteBuffer.TextLength;
                    if (TxtLength % 3 == 0)
                    {
                        strModify = "0" + e.KeyChar;
                    }
                    else if (TxtLength % 3 == 2)
                    {
                        strModify = strOld.Substring(TxtLength - 1, 1) + e.KeyChar + " ";
                        strOld = strOld.Substring(0, TxtLength - 2);
                    }
                    else
                    {
                        strModify = "";
                    }
                    textBoxWriteBuffer.Text = strOld + strModify;
                    textBoxWriteBuffer.SelectionStart = textBoxWriteBuffer.TextLength;
                    e.Handled = true;
                }
                else if ((e.KeyChar >= 97) && (e.KeyChar <= 102))
                {
                    strOld = textBoxWriteBuffer.Text;
                    TxtLength = textBoxWriteBuffer.TextLength;
                    if (TxtLength % 3 == 0)
                    {
                        strModify = "0" + e.KeyChar;
                    }
                    else if (TxtLength % 3 == 2)
                    {
                        strModify = strOld.Substring(TxtLength - 1, 1) + e.KeyChar + " ";
                        strOld = strOld.Substring(0, TxtLength - 2);
                    }
                    else
                    {
                        strModify = "";
                    }
                    textBoxWriteBuffer.Text = strOld + strModify;
                    textBoxWriteBuffer.SelectionStart = textBoxWriteBuffer.TextLength;
                    e.Handled = true;
                }
                else
                {
                    e.Handled = true;
                }
            }
        }  
    }
}
