﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

[StructLayout(LayoutKind.Sequential)]
public struct MW_EasyPOD
{
    public UInt32 VID;			        // Need to match user device's "Vendor ID".
    public UInt32 PID;			        // Need to match user device's "Product ID".
    public UInt32 ReadTimeOut;		    // Specifies the read data time-out interval, in milliseconds.
    public UInt32 WriteTimeOut;		    // Specifies the write data time-out interval, in milliseconds.    
    public IntPtr Handle;                 // Do not modify this value, reserved for DLL
    public UInt32 FeatureReportSize;      // Do not modify this value, reserved for DLL
    public UInt32 InputReportSize;        // Do not modify this value, reserved for DLL
    public UInt32 OutputReportSize;       // Do not modify this value, reserved for DLL   
} 

    
class PODfuncs
{
    [DllImport("EasyPODx64.dll", CallingConvention = CallingConvention.StdCall)]
    unsafe public static extern UInt32 ConnectPOD(MW_EasyPOD* pEasyPOD, UInt32 Index);

    [DllImport("EasyPODx64.dll", CallingConvention = CallingConvention.StdCall)]
    unsafe public static extern UInt32 WriteData(MW_EasyPOD* pEasyPOD, byte[] lpBuffer, UInt32 nNumberOfBytesToWrite, UInt32* lpNumberOfBytesWritten);

    [DllImport("EasyPODx64.dll", CallingConvention = CallingConvention.StdCall)]
    unsafe public static extern UInt32 ReadData(MW_EasyPOD* pEasyPOD, byte[] lpBuffer, UInt32 nNumberOfBytesToRead, UInt32* lpNumberOfBytesRead);

    [DllImport("EasyPODx64.dll", CallingConvention = CallingConvention.StdCall)]
    unsafe public static extern UInt32 DisconnectPOD(MW_EasyPOD* pEasyPOD);

    [DllImport("EasyPODx64.dll", CallingConvention = CallingConvention.StdCall)]
    unsafe public static extern UInt32 ClearPODBuffer(MW_EasyPOD* pEasyPOD);
}


