Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Module Module1

    Public Const ERROR_SUCCESS As Integer = &H0
    Public Const USER_DEFINE_ERROR As Integer = &HE0000000
    Public Const INSUFFICIENT_MOMORY_AVAILABLE As Integer = &HE0000001
    Public Const HIDD_GETATTRIBUTES_FAIL As Integer = &HE0000002
    Public Const CANNOT_FINDE_THE_DEVICE_SPECIFIED As Integer = &HE0000003
    Public Const SEND_DEVICE_CHECKCODE_FAIL As Integer = &HE0000004
    Public Const GET_DEVICE_CHECKCODE_FAIL As Integer = &HE0000005
    Public Const CHECK_DEVICE_CHECKCODE_FAIL As Integer = &HE0000006
    Public Const CALL_WRITE_DATA_TIMEOUT As Integer = &HE0000007
    Public Const CALL_READ_DATA_TIMEOUT As Integer = &HE0000008
    Public Const ALLOCATE_DEVICE_QUEUE_FAIL As Integer = &HE0000009
    Public Const GET_INPUT_REPORT_SIZE_FAIL As Integer = &HE000000A
    Public Const DELETE_INPUT_QUEUE_FAIL As Integer = &HE000000B

    <StructLayout(LayoutKind.Sequential, Pack:=1)> Public Structure MW_EasyPOD
        Public VID As UInteger
        Public PID As UInteger
        Public ReadTimeOut As UInteger
        Public WriteTimeOut As UInteger
        Public Handle As IntPtr ' Do not modify this value, reserved for DLL
        Public FeatureReportSize As UInteger ' Do not modify this value, reserved for DLL
        Public InputReportSize As UInteger ' Do not modify this value, reserved for DLL
        Public OutputReportSize As UInteger ' Do not modify this value, reserved for DLL
    End Structure

    <DllImport("EasyPODx64.dll",
    CallingConvention:=CallingConvention.StdCall)> _
    Public Function ConnectPOD(ByRef m_EasyPod As MW_EasyPOD, ByVal Index As Integer) As UInteger
    End Function

    <DllImport("EasyPODx64.dll",
    CallingConvention:=CallingConvention.StdCall)> _
    Public Function DisconnectPOD(ByRef m_EasyPod As MW_EasyPOD) As UInteger
    End Function

    <DllImport("EasyPODx64.dll",
    CallingConvention:=CallingConvention.StdCall)> _
    Public Function ClearPODBuffer(ByRef m_EasyPod As MW_EasyPOD) As UInteger
    End Function


    <DllImport("EasyPODx64.dll",
    CallingConvention:=CallingConvention.StdCall)> _
    Public Function WriteData(ByRef m_EasyPod As MW_EasyPOD, ByVal OutBuffer As Byte(), ByVal nNumberOfBytesToWrite As UInt32, ByRef lpNumberOfBytesWritten As UInt32) As Integer
    End Function

    <DllImport("EasyPODx64.dll",
    CallingConvention:=CallingConvention.StdCall)> _
    Public Function ReadData(ByRef m_EasyPod As MW_EasyPOD, ByVal InBuffer As Byte(), ByVal nNumberOfBytesToRead As UInt32, ByRef lpNumberOfBytesRead As UInt32) As Integer
    End Function

End Module