﻿Imports System
Imports System.IO.Ports
Imports System.Threading
Imports System.Globalization



Public Structure UserInput
    Dim ArrayData() As Char
    Dim Count As Integer
End Structure
Public Class Form1
#Region "Enum"
    Public Enum Devices
        EasyPOD = 0
        EasyCOM = 1
    End Enum
#End Region
    Private CommPort As New RS232()
    Private m_EasyPOD As MW_EasyPOD
    Private m_Input As UserInput
    Private bBackSpace As Boolean
    Private UserInput(1) As Byte
    Private InputBuffer(1) As Byte
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer

        RadioButtonHex.Checked = True

        ComboBoxDevices.Items.Add("EasyPOD")
        ComboBoxDevices.Items.Add("EasyCOM")
        ComboBoxDevices.SelectedIndex = 0

        TextBoxVID.Text = "0E6A"
        TextBoxPID.Text = "0317"
        TextBoxIndex.Text = "1"


        ComboBoxBaudrate.Items.Add("1200")
        ComboBoxBaudrate.Items.Add("2400")
        ComboBoxBaudrate.Items.Add("4800")
        ComboBoxBaudrate.Items.Add("9600")
        ComboBoxBaudrate.Items.Add("14400")
        ComboBoxBaudrate.Items.Add("19200")
        ComboBoxBaudrate.Items.Add("38400")
        ComboBoxBaudrate.Items.Add("56000")
        ComboBoxBaudrate.Items.Add("57600")
        ComboBoxBaudrate.Items.Add("115200")
        ComboBoxBaudrate.SelectedIndex = 0
        ComboBoxBaudrate.Visible = False


        For i = 1 To 16
            ComboBoxCOMPorts.Items.Add("COM" & i)
        Next
        ComboBoxCOMPorts.SelectedIndex = 0
        ComboBoxCOMPorts.Visible = False

        ReDim Preserve m_Input.ArrayData(20)
        bBackSpace = False

    End Sub

    Private Sub ComboBoxDevices_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxDevices.SelectedIndexChanged
        If ComboBoxDevices.SelectedIndex = 0 Then  'EasyPOD
            GroupBoxSetting.Height = 112
            ComboBoxBaudrate.Visible = False
            ComboBoxCOMPorts.Visible = False
            TextBoxVID.Visible = True
            TextBoxPID.Visible = True
            TextBoxIndex.Visible = True
            LabelVID.Visible = True
            LabelPID.Visible = True
            LabelIndex.Visible = True
        Else                                       'EasyCOM 
            GroupBoxSetting.Height = 90
            ComboBoxBaudrate.Visible = True
            ComboBoxCOMPorts.Visible = True
            TextBoxVID.Visible = False
            TextBoxPID.Visible = False
            TextBoxIndex.Visible = False
            LabelVID.Visible = False
            LabelPID.Visible = False
            LabelIndex.Visible = False
        End If
    End Sub

    Private Sub ButtonConnect_Click(sender As System.Object, e As System.EventArgs) Handles ButtonConnect.Click
        Dim DeviceIndex As Integer
        Dim Baudrate As Integer
        Dim PortNo As Integer
        Dim dwResult As ULong
        DeviceIndex = ComboBoxDevices.SelectedIndex
        If DeviceIndex = Devices.EasyPOD Then
            If ((Trim(TextBoxVID.Text) = "") Or (Trim(TextBoxPID.Text) = "") Or (Trim(TextBoxIndex.Text) = "")) Then
                MsgBox("VID or PID or Index must have value")
                Exit Sub
            End If            
            m_EasyPOD.VID = UInt32.Parse(TextBoxVID.Text.ToString.ToUpper, NumberStyles.HexNumber)
            m_EasyPOD.PID = UInt32.Parse(TextBoxPID.Text.ToString.ToUpper, NumberStyles.HexNumber)
            If (m_EasyPOD.Handle <> vbFalse) Then
                dwResult = DisconnectPOD(m_EasyPOD)
            End If
            dwResult = ConnectPOD(m_EasyPOD, 1)
            If (dwResult = ERROR_SUCCESS) Then
                StatusStrip1.Items(0).Text = "Open Successfully !"
                m_EasyPOD.WriteTimeOut = 500
                m_EasyPOD.ReadTimeOut = 100
            Else
                StatusStrip1.Items(0).Text = "Open Fail !"
            End If
        ElseIf DeviceIndex = Devices.EasyCOM Then
            PortNo = ComboBoxCOMPorts.SelectedIndex + 1
            Baudrate = CInt(ComboBoxBaudrate.SelectedItem)
            Try
                If CommPort.IsOpen() = True Then
                    CommPort.Close()
                End If
                CommPort.Open(PortNo, Baudrate, 8, RS232.DataParity.Parity_None, RS232.DataStopBit.StopBit_1, 4096)
                StatusStrip1.Items(0).Text = "Open Successfully !"
            Catch
                'Open Comm Port Fail
                StatusStrip1.Items(0).Text = "Open Fail !"
            End Try
        End If

    End Sub

    Private Sub ButtonDisconnect_Click(sender As System.Object, e As System.EventArgs) Handles ButtonDisconnect.Click
        Dim DeviceIndex As Integer
        Dim dwResult As ULong
        DeviceIndex = ComboBoxDevices.SelectedIndex
        If DeviceIndex = Devices.EasyPOD Then
            If (m_EasyPOD.Handle <> vbFalse) Then
                dwResult = ClearPODBuffer(m_EasyPOD)
                dwResult = DisconnectPOD(m_EasyPOD)
                If (dwResult = ERROR_SUCCESS) Then
                    StatusStrip1.Items(0).Text = "Close Successfully !"
                    TextBoxReadBuffer.Clear()
                    TextBoxWriteBuffer.Clear()
                Else
                    StatusStrip1.Items(0).Text = "Close Fail !"
                End If
            End If
        ElseIf DeviceIndex = Devices.EasyCOM Then
            Try
                If CommPort.IsOpen() Then
                    CommPort.Close()
                End If
                StatusStrip1.Items(0).Text = "Close Successfully !"
                TextBoxReadBuffer.Clear()
                TextBoxWriteBuffer.Clear()
            Catch
                'Open Comm Port Fail
                StatusStrip1.Items(0).Text = "Close Fail !"
            End Try
        End If
    End Sub

    Private Sub ButtonExit_Click(sender As System.Object, e As System.EventArgs) Handles ButtonExit.Click
        End
    End Sub

    Private Sub RadioButtonHex_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButtonHex.CheckedChanged
        If RadioButtonHex.Checked() = True Then
            TextBoxWriteBuffer.Clear()
        End If
    End Sub

    Private Sub RadioButtonString_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButtonString.CheckedChanged
        If RadioButtonString.Checked() = True Then
            TextBoxWriteBuffer.Clear()
        End If
    End Sub

    Private Sub TextBoxWriteBuffer_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles TextBoxWriteBuffer.KeyPress
        Dim KeyInput As Char = e.KeyChar
        Dim KeyAscii As Integer = Asc(e.KeyChar)
        If (RadioButtonString.Checked() = True) Then
            'TextBoxWriteBuffer.Text.CopyTo(0, m_Input.ArrayData, 0, TextBoxWriteBuffer.TextLength)
        Else
            Select Case (KeyInput)
                Case vbBack
                    bBackSpace = True
                Case vbLf
                Case "0" To "9"
                    bBackSpace = False
                Case "A" To "F"
                    bBackSpace = False
                Case "a" To "f"
                    bBackSpace = False
                    e.KeyChar = Char.ToUpper(e.KeyChar)
                Case Else
                    e.KeyChar = CChar(vbNullChar)
                    e.Handled = True
            End Select
        End If
    End Sub

    Private Sub TextBoxWriteBuffer_TextChanged(sender As System.Object, e As System.EventArgs) Handles TextBoxWriteBuffer.TextChanged
        Dim TextLength As Integer
        If (RadioButtonHex.Checked() = True) Then
            TextLength = TextBoxWriteBuffer.TextLength
            If bBackSpace = False Then
                If ((TextLength Mod 3) = 0) And TextLength > 0 Then
                    If (TextBoxWriteBuffer.Text.Last() <> Chr(Keys.Space)) Then
                        TextBoxWriteBuffer.SelectionStart = TextBoxWriteBuffer.TextLength - 3
                        TextBoxWriteBuffer.SelectionLength = 1
                        TextBoxWriteBuffer.Paste("")
                        TextBoxWriteBuffer.SelectionStart = TextBoxWriteBuffer.TextLength
                        TextBoxWriteBuffer.SelectionLength = 0
                        TextBoxWriteBuffer.Paste(" ")
                    End If
                ElseIf ((TextLength Mod 3) = 1) Then
                    TextBoxWriteBuffer.SelectionStart = TextBoxWriteBuffer.TextLength - 1
                    TextBoxWriteBuffer.SelectionLength = 0
                    TextBoxWriteBuffer.Paste("0")
                    TextBoxWriteBuffer.SelectionStart = TextBoxWriteBuffer.TextLength + 1
                    TextBoxWriteBuffer.SelectionLength = 0
                End If
            Else
                If ((TextLength Mod 3) = 2) Then
                    TextBoxWriteBuffer.SelectionStart = TextBoxWriteBuffer.TextLength - 1
                    TextBoxWriteBuffer.SelectionLength = 1
                    TextBoxWriteBuffer.Paste("")
                End If
            End If
        End If
    End Sub
    Private Function GetUserInput(ByRef InputBuffer() As Byte, ByVal BufferLength As Integer) As Integer
        Dim i As Integer
        Dim Index As Integer
        Dim TextLength As Integer
        Dim Token As String
        If (RadioButtonHex.Checked() = True) Then
            If BufferLength = 0 Then
                TextBoxWriteBuffer.Text.TrimEnd()
                TextLength = (TextBoxWriteBuffer.TextLength + 1) / 3
            Else
                Index = 0
                For i = 0 To TextBoxWriteBuffer.TextLength - 1 Step 3
                    Token = TextBoxWriteBuffer.Text.ToString.Substring(i, 2)                    
                    InputBuffer(Index) = Byte.Parse(Token, NumberStyles.HexNumber)
                    Index = Index + 1
                Next
            End If
        Else
            If BufferLength = 0 Then
                TextLength = TextBoxWriteBuffer.TextLength
            Else
                Index = 0
                For i = 0 To TextBoxWriteBuffer.TextLength - 1
                    InputBuffer(Index) = Asc(TextBoxWriteBuffer.Text.ToString.Substring(i))
                    Index = Index + 1
                Next
            End If
        End If
        Return TextLength
    End Function
    Private Sub ButtonWriteBytes_Click(sender As System.Object, e As System.EventArgs) Handles ButtonWriteBytes.Click

        Dim InputLength As UInt32
        Dim byteWritten As UInt32
        Dim dwResult As Integer
        InputLength = GetUserInput(UserInput, 0)
        If (InputLength > 0) Then
            ReDim Preserve UserInput(InputLength - 1)
            GetUserInput(UserInput, InputLength)
            dwResult = WriteData(m_EasyPOD, UserInput, InputLength, byteWritten)
            If (dwResult = ERROR_SUCCESS) Or (dwResult = CALL_WRITE_DATA_TIMEOUT) Then
                StatusStrip1.Items(0).Text = String.Format("Write return size is {0}", byteWritten)
            End If
        End If
    End Sub

    Private Sub ButtonReadBytes_Click(sender As System.Object, e As System.EventArgs) Handles ButtonReadBytes.Click
        ReDim Preserve InputBuffer(100)
        Dim byteRead As UInt32
        Dim byteToRead As UInt32
        Dim dwResult As Integer
        Dim i As Integer
        Dim strOutput As String
        Dim TotalCount As Integer
        byteToRead = 100
        strOutput = ""
        TotalCount = 0
        Do
            dwResult = ReadData(m_EasyPOD, InputBuffer, byteToRead, byteRead)
            If (byteRead > 0) And ((dwResult = ERROR_SUCCESS) Or (dwResult = CALL_READ_DATA_TIMEOUT)) Then
                If (RadioButtonHex.Checked() = True) Then
                    For i = 0 To byteRead - 1
                        'strOutput = strOutput + Hex(InputBuffer(i)) + " "
                        strOutput = strOutput + Format(InputBuffer(i), "X2") + " "
                    Next i
                    strOutput.TrimEnd()
                Else
                    For i = 0 To byteRead - 1
                        strOutput = strOutput + Chr(InputBuffer(i))
                    Next i
                End If
                TotalCount = TotalCount + byteRead
            End If
        Loop While (byteRead > 0 And ((dwResult = ERROR_SUCCESS) Or (dwResult = CALL_READ_DATA_TIMEOUT)))

        TextBoxReadBuffer.Text = strOutput
        StatusStrip1.Items(0).Text = String.Format("Read return size is {0}", TotalCount)

    End Sub
End Class
